<!DOCTYPE html>
<html>

<head>
  <meta charset="UTF-8">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>Lucky Dice Username</h2>
    <div class="form-group">
      <label for="username">User name:</label>
      <input type="email" class="form-control" id="input-username" placeholder="Enter username" name="username">
    </div>
    <div class="form-group">
      <button type="button" class="btn btn-primary" onclick="onBtnShowVoucherHistoryClick()">Show Voucher History
        Table</button>
    </div>
    <div id="log-result" class="mt-5"></div>
    <div class="mt-5">
      <table id="table-voucher-history" class="table table-striped table-bordered table-hover">
        <thead>
          <tr>
            <th>Mã Giảm Giá</th>
            <th>Phần trăm giảm giá</th>
          </tr>
        </thead>
        <tbody id="tbody-voucher-history">

        </tbody>
      </table>
    </div>
  </div>

  <script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gEND_OF_ROW_COL = -1;
    const gCOL_MA_VOUCHER = 0;
    const gCOL_PHAN_TRAM_GIAM_GIA = 1;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện nút show dice history
    function onBtnShowVoucherHistoryClick() {
      //khai báo đối tượng để chưá dữ liệu trên form
      var vUserObj = {
        username: ""
      };
      //B1: thu thập dữ liệu
      thuThapDuLieu(vUserObj);

      //B2: validate
      var vDuLieuHopLe = kiemTraDuLieu(vUserObj);
      if (vDuLieuHopLe) {
        var vXmlHttpDiceHistory = new XMLHttpRequest();
        //B3: gọi api để lấy lịch sử tung xúc  xắc
        goiApiLayLichSuVoucher(vUserObj, vXmlHttpDiceHistory);
        //B4: hiển thị lịch sử tung xúc xắc lên table
        vXmlHttpDiceHistory.onreadystatechange =
          function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
              hienThiLichSuVoucher(vXmlHttpDiceHistory);
            }
          }
      }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function thuThapDuLieu(paramUserObj) {
      var vUserNameInput = document.getElementById("input-username");
      paramUserObj.username = vUserNameInput.value.trim();
    }

    function kiemTraDuLieu(paramUserObj) {
      if (paramUserObj.username == "") {
        alert("Enter username!");
        return false;
      }

      return true;
    }

    function goiApiLayLichSuVoucher(paramUserObj, paramXmlHttp) {
      paramXmlHttp.open("GET", gBASE_URL + "/voucher-history?username=" + paramUserObj.username, true);
      paramXmlHttp.send();
    }

    function hienThiLichSuVoucher(paramXmlHttp) {
      console.log(paramXmlHttp.responseText);
      var vVoucherHistoryObj = JSON.parse(paramXmlHttp.responseText);
      var vVoucherHistoryTBody = document.getElementById("table-voucher-history");
      //xóa trắng bảng dữ liệu
      vVoucherHistoryTBody.innerHTML = "";
      for (var bI = 0; bI < vVoucherHistoryObj.vouchers.length; bI++) {
        // thêm 1 dòng mới và gắn vào table
        var bNewRow = vVoucherHistoryTBody.insertRow(gEND_OF_ROW_COL);
        // thêm 2 ô trên dòng mới
        var bMaGiamGiaCell = bNewRow.insertCell(gCOL_MA_VOUCHER);
        var bPhanTramGiamGiaCell = bNewRow.insertCell(gCOL_PHAN_TRAM_GIAM_GIA);
        // điền dữ liệu cho từng ô
        bMaGiamGiaCell.innerHtml = vVoucherHistoryObj.vouchers[bI].maVoucher;
        bPhanTramGiamGiaCell.innerHtml = vVoucherHistoryObj.vouchers[bI].phanTramGiamGia + " %";
      }
    }
  </script>


</body>

</html>